#ifndef H_ASTEROID
#define H_ASTEROID

#include "MassObject.h"

class Expression;

class Asteroid:public MassObject{
    public:
    double live;

    virtual void draw();
    virtual int getType();
    virtual void serialize(std::vector<unsigned char>& destination);
    static Asteroid* deserialize(std::vector<unsigned char>::iterator&
            it);
    virtual void doDamage(double impactDamage, double explosionDamage,
            int from, World* world);

    void setRadius(double radius);

    Asteroid();
    virtual ~Asteroid();
    virtual void destroy(World* world);

    static void initialize();
    static double minSpawnRadius;
    static double density;
    static double radiusToLive;
    static double splitRadius;
    static double splitVelocityFactor;

};

#endif
