#ifndef H_EXPLOSION
#define H_EXPLOSION

#include "Affector.h"

class Explosion: public Affector{
    public:
        static double expandSpeed;
        static double minimalDamage;
        static double impactFactor;
        static double impactDamage;
        static double decay;

        Point velocity;
        double damagePerSecond;
        double timeDelta;

        virtual void timeNotify(double timeDelta);
        Explosion();
        virtual ~Explosion();

        static void initialize();

        virtual void affect(MassObject* object, World* world);
        
        double damagePerAngle();

        double getExplosionRange(double objectDistance, double
                objectRadius);

        virtual int getType();
        virtual void serialize(std::vector<unsigned char>&
                destination);
        static Explosion* deserialize(std::vector<unsigned
                char>::iterator& it);

};

#endif
