#ifndef PBE_OBJ_H_
	#define PBE_OBJ_H_

	#define PI 	 3.1415926535897932384626433832795


//	#define PBE_BENCHMARK_MODE
	#define PBE_BENCHMARK_FRAMES	10000
	#define PBE_BENCHMARK_MODULO	1000
	#define PBE_F_COUNT				100

	#define PBE_MAX_OBJECT_TYPES	128

	#define PBE_OGL_VER_MAJOR		"0"
	#define PBE_OGL_VER_MINOR		"1"
	#define PBE_OGL_VER_REVISION	"0"
	#define PBE_OGL_VER_COMMENT		"45a"
	#define PBE_OGL_VERSION			"Proboj OpenGL Engine" << PBE_OGL_VER_MAJOR << "." << PBE_OGL_VER_MINOR << "." << PBE_OGL_VER_REVISION << "-" << PBE_OGL_VER_COMMENT


	#define PBE_ONE_SCREEN		0
	#define PBE_SCREEN_LEFT_TOP	1
	#define PBE_SCREEN_LEFT_BOTTOM	2
	#define PBE_SCREEN_RIGHT_TOP	3
	#define PBE_SCREEN_RIGHT_BOTTOM	4

	#define PBE_SCREEN_CROP_BORDER	0

	#define PBE_WINDOW_INIT_WIDTH		800
	#define PBE_WINDOW_INIT_HEIGHT		600



	//da f'in shipz
	#define GFX_OBJ_SHIPA			0
	#define GFX_OBJ_SHIPB			1
	#define GFX_OBJ_SHIPC			2
	#define GFX_OBJ_SHIPD			3
	#define GFX_OBJ_SHIPE			4

	//da obdz~ektz
	#define GFX_OBJ_BLACKHOLE_CW	15
	#define GFX_OBJ_BLACKHOLE_CCW	16
	#define GFX_OBJ_ASTEROID		17
	#define GFX_OBJ_TWIRLER_CW		18
	#define GFX_OBJ_TWIRLER_CCW		19
	#define GFX_OBJ_NEBULA			20
	#define GFX_OBJ_EXPLOSION		21

	//da wepnz
	#define GFX_OBJ_WEAPON_PLASMA	30
	#define GFX_OBJ_WEAPON_CANON	31
	#define GFX_OBJ_WEAPON_MISSILE	32
	#define GFX_OBJ_WEAPON_FORK		33
	#define GFX_OBJ_WEAPON_MAGNET	34

	#define GFX_BACKGROUND_TEXTURE	47


	//#include "ObjectGraphics.h"

	#include <string>
	#include <iostream>
	#include <GL/gl.h>
	#include <GL/glu.h>
	#include <GL/glut.h>
	#include <IL/il.h>
	#include <IL/ilu.h>
	#include <stdio.h>
 	#include <vector>

	using namespace std;
	
	struct texInfo {
		int sizeX, sizeY;
		bool loaded;
		GLuint hnd;
	};

	class BasicObject;
	class Surface;
	class Ship;
	class Twirler;
	class BlackHole;
	class Nebula;
	class Asteroid;
	class Missile;
	class PlasmaBall;
	class CannonBall;
	
	
	class PBE_obj {
		private:
			//aktivne opengl okno
			int window;

			#ifdef PBE_BENCHMARK_MODE
				int iBomb;
			#endif

			char sBuff[1000];		//vypisovackovy buffer

			bool bSpritesLoaded;
			struct texInfo texs[PBE_MAX_OBJECT_TYPES];

			int screen_num;

			//tieto 4 sa velmi lubia, nemozu bez seba zit :)
			int getNextPowerOfTwo(int fold);
			static bool isValidTextureIndex(int index);
			bool loadTextureFromFile(string sFileName, int texIndex);			
			bool loadSprites();
			

			void initGLUTwrapper(int argc, char** argv, int w, int h); //toto ide priamo z callu constructora

			static void draw(float x, float y, float z, float width, float height, int type, float alpha, float scaleX, float scaleY, float scaleZ);

			
			/* hooky na GLUT :) */
			
			

		public:
			static float gtX, gtY, ltX, ltY;
			static float pX, kX, pY, kY;

			static void flip();									//glSwapBuffers
		    static void begin();								//glClear
		    static void drawBasicObject(BasicObject* object);	//het
		    static void drawShip(Ship* object);
		    static void drawAsteroid(Asteroid* object);
		    static void drawTwirler(Twirler* object);
		    static void drawBlackHole(BlackHole* object);
		    static void drawNebula(Nebula* object);
		    static void drawMissile(Missile* object);
		    static void drawPlasmaBall(PlasmaBall* object);
		    static void drawCannonBall(CannonBall* object);
		    static void _drawObject(BasicObject* object, int R, int G, int B);
			static void calibrateCrop();
			static bool isVisible(float x, float y);
			static float fX(float x);
			static float fY(float y);
		    //static Metric m;
		    //static int show;
			static PBE_obj *po;
			static bool bCalibarted;
			static int world_width, world_height;

			PBE_obj(int w, int h, int screen_num);		
			~PBE_obj();
		    
	};


#endif /*PBE_OBJ_H_*/
