#ifndef H_PLASMA_BALL
#define H_PLASMA_BALL

#include "Weapon.h"

class PlasmaBall: public Weapon{
    public:
        static double detonatingImpact;
        static double detonatingDamage;
        static double detonatingPlasmaToPlasmaDamage;
        static double defaultRadius;
        static double defaultMass;
        static double defaultAngularMass;

        double damage;
        Point explosionVelocity;


        virtual int getType();
        virtual void doDamage(double impactDamage, double
                explosionDamage,int from, World* world);
        void doPlasmaCollision(PlasmaBall* another);

        virtual void destroy(World* world); 
        virtual void draw();
        virtual ~PlasmaBall();
        PlasmaBall();

        static void initialize();
        virtual void serialize(std::vector<unsigned char>& destination);
        static PlasmaBall* deserialize(std::vector<unsigned char>::iterator&
            it);



};

#endif
