#include "PBE_OGL.h"
#include "glut_wrapper.h"

using namespace std;

bool fullscreen;
int window;
int my_x = 50, my_y = 50, my_width = kWindowWidth, my_height = kWindowHeight;
int fps_limit = 30000;

PBE_obj po;

char sBuff[1000];

//bitmap_font_linux* bfl;
//bitmap_font_linux* bfl_hmsg;

GLuint dlHelp, dlLightsStdOn, dlLightsStdOff, dlBlendingOn, dlBlendingOff;


bool initGL(void) {
    glShadeModel(GL_SMOOTH);
    glClearColor(0.0f, 0.0f, 0.0f, 0.5f);	// cierne pozadie
    glClearDepth(1.0f);						// buffer pamati hlbky

    glEnable(GL_DEPTH_TEST);				// zapni pamat hlbky
    glDepthFunc(GL_LEQUAL);					// typ testu v pamati hlbky
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glEnable(GL_BLEND);

    po.loadSprites();

//    bfl = new bitmap_font_linux("");
//    bfl_hmsg = new bitmap_font_linux("-*-arial-*-*-*-*-12-*-*-*-*-*-iso8859-2");

    return true;
}



int destroyGL() {
//	delete bfl_hmsg;
//	delete bfl;
    glutDestroyWindow(window);
    exit(0);
}



void render(void) {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glMatrixMode(GL_MODELVIEW);

    po.parseInput();
    po.draw();

    glutSwapBuffers();
}



void reshape(int w, int h) {
    if (!fullscreen) {
        my_width = w;
        my_height = h;
    } else {
        cout << w << "x" << h << endl;
    }


    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0, (float) w/(float) h, 1.0, 5000.0);
    glMatrixMode(GL_MODELVIEW);

}



void keyboard(unsigned char key, int x, int y) {
	switch (key) {
    	
        case 'q':
        case 'Q':
        case KEY_ESCAPE:
            destroyGL();
            break;
        	
        default:
        	printf("kb: %d\n", key);
    }

    render();
}



void special_keys(int a_keys, int x, int y) {
	switch (a_keys) {
        case GLUT_KEY_F1:
            fullscreen =! fullscreen;                 // Toggle Fullscreen / Windowed Mode

            if (fullscreen) {
                glutFullScreen();
            } else {
                glutPostRedisplay();
            }
            break;

        default:
        	printf("kb: %d\n", a_keys);

    }
}



void mouse(int button, int state, int x, int y) {

}




int initGLUTwrapper(int argc, char** argv) {		
    glutInit(&argc, argv);
    glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH); //GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize (my_width, my_height);
    glutInitWindowPosition (my_x, my_y);

    sprintf(sBuff, "\nKSP 47 Proboj Engine v.%s.%s.%s-%s\n", VER_MAJOR, VER_MINOR, VER_REVISION, VER_COMMENT);    
    window = glutCreateWindow ((char *) sBuff);
    initGL();

    // callback functions
    glutDisplayFunc(render);
    glutIdleFunc(render);
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutMouseFunc(mouse);
    glutSpecialFunc(special_keys);

    glutMainLoop();

    return 0;
}
