#include "BasicObject.h"
#include "Serializer.h"
#include "Types.h"
#include "PBE_obj.h"

int BasicObject::last_id=0;

// {{{ ~BasicObject
BasicObject::~BasicObject(){

}
// }}}

// {{{ _serialize
void BasicObject::_serialize(std::vector<unsigned char>& destination,
        BasicObject* ptr){
    Serializer::serializeInt(destination,ptr->id);
    Serializer::serializeChar(destination,ptr->visible);
    Serializer::serializePoint(destination,ptr->position);
    Serializer::serializeFloat(destination,ptr->angle);
    Serializer::serializeFloat(destination,ptr->radius);
}
// }}}

// {{{ _deserialize
void BasicObject::_deserialize(std::vector<unsigned char>::iterator&
              it, BasicObject* ptr){
    ptr->id=Serializer::deserializeInt(it);
    ptr->visible=Serializer::deserializeChar(it);
    ptr->position=Serializer::deserializePoint(it);
    ptr->angle=Serializer::deserializeFloat(it);
    ptr->radius=Serializer::deserializeFloat(it);
}
// }}}


// {{{ BasicObject
BasicObject::BasicObject():id(last_id++),
radius(1),angle(0),position(Point(0,0)),visible(true),alive(true),owner(-1){
}
// }}}

// {{{ timeNotify
void BasicObject::timeNotify(double timeDelta){
}
// }}}

// {{{ clean
void BasicObject::clean(){
    alive=true;
    visible=true;
}
// }}}

// {{{ draw
void BasicObject::draw(){
    PBE_obj::drawBasicObject(this);

}
// }}}

// {{{ copyData
void BasicObject::copyData(const BasicObject* from, BasicObject* to){
    to->id=from->id;
    to->radius=from->radius;
    to->angle=from->angle;
    to->position=from->position;
    to->visible=from->visible;
    to->alive=from->alive;
    to->owner=from->owner;
}
// }}}
