#include "BlackHole.h"
#include "Types.h"
#include "PBE_obj.h"
#include "Serializer.h"

#include "Debug.h"

// {{{ ~BlackHole
BlackHole::~BlackHole(){
}
// }}}

// {{{ getType OK
int BlackHole::getType(){
    return Types::blackHole;
}
// }}}

// {{{ draw OK
void BlackHole::draw(){
    PBE_obj::drawBlackHole(this);
}
// }}}

// {{{ serialize OK
void BlackHole::serialize(std::vector<unsigned char>&
        destination){

    Serializer::serializeChar(destination,Types::blackHole);
    Serializer::serializeChar(destination,visible);

    Serializer::serializeInt(destination,id);
    Serializer::serializePoint(destination,position);
    Serializer::serializeFloat(destination,radius);

    Serializer::serializeFloat(destination,mass);
    Serializer::serializePoint(destination,velocity);
}
// }}}

// {{{ deserialize OK
MassObject* BlackHole::deserialize(std::vector<unsigned
        char>::iterator & it){

    BlackHole* ptr=new BlackHole();

    ptr->visible=   Serializer::deserializeChar(it);
    ptr->id=        Serializer::deserializeInt(it);
    ptr->position=  Serializer::deserializePoint(it);
    ptr->radius=    Serializer::deserializeFloat(it);

    ptr->mass=      Serializer::deserializeFloat(it);
    ptr->velocity=  Serializer::deserializePoint(it);

    ptr->angle=0;
    ptr->angularMass=0.5*ptr->mass*ptr->radius*ptr->radius;
    ptr->angularVelocity=0;
    return ptr;
}
// }}}
    
