#include "MassObject.h"
#include "Types.h"
#include "Serializer.h"
#include "World.h"

// {{{ ~MassObject
MassObject::~MassObject(){

}
// }}}

// {{{ MassObject OK
MassObject::MassObject():BasicObject(),mass(1),velocity(Point(0,0)),angularMass(1),angularVelocity(0){

}
// }}}

// {{{ clean OK
void MassObject::clean(){
    alive=true;
    visible=true;

    positionDelta=Point();
    angularDelta=0;
    angularVelocityDelta=0;
    velocityDelta=Point();
    alive=true;
    timeDelta=0;
}
// }}}

// {{{ destroy OK
void MassObject::destroy(World* world){

}
// }}}

// {{{ _serialize OK
void MassObject::_serialize(std::vector<unsigned char>& destination,
        MassObject* ptr){
    BasicObject::_serialize(destination,ptr);

    Serializer::serializeFloat(destination,ptr->mass);
    Serializer::serializePoint(destination,ptr->velocity);
    Serializer::serializeFloat(destination,ptr->angularMass);
    Serializer::serializeFloat(destination,ptr->angularVelocity);
}
// }}}

// {{{ _deserialize OK
void MassObject::_deserialize(std::vector<unsigned char>::iterator&
        it, MassObject* ptr){

    ptr->clean();
    BasicObject::_deserialize(it,ptr);
    ptr->mass=      Serializer::deserializeFloat(it);
    ptr->velocity=  Serializer::deserializePoint(it);
    ptr->angularMass=Serializer::deserializeFloat(it);
    ptr->angularVelocity=Serializer::deserializeFloat(it);
}
// }}}

// {{{ doDamage OK
void MassObject::doDamage(double impactDamage, double explosionDamage, int from, World* world){
  if (impactDamage>=INFINITE_DAMAGE) {alive=false; impactDamage=0; }
  world->playerStatistics.addDamage(from,impactDamage+explosionDamage,0,-1);
}
// }}}

// {{{ copyData  OK
void MassObject::copyData(const MassObject* from, MassObject* to){
    to->clean();
    BasicObject::copyData(from,to);
    to->mass=from->mass;
    to->velocity=from->velocity;
    to->angularMass=from->angularMass;
    to->angularVelocity=from->angularVelocity;
}
// }}}
