#include <iostream>
#include <cmath>

#include "Nebula.h"
#include "World.h"
#include "MassObject.h"
#include "Types.h"
#include "PBE_obj.h"
#include "Serializer.h"
#include "Random.h"

// {{{ affect
void Nebula::affect(MassObject* object, World* world){
    object->visible=false;
}
// }}}

// {{{ draw
void Nebula::draw(){
    PBE_obj::drawNebula(this);
}
// }}}

// {{{ getType
int Nebula::getType(){
    return Types::nebula;
}
// }}}

// {{{ Nebula
Nebula::Nebula(){
    angle=Random::getDouble(2*M_PI);
}
// }}}

// {{{ ~Nebula
Nebula::~Nebula(){

}
// }}}

// {{{ serialize
void Nebula::serialize(std::vector<unsigned char>& destination){
    Serializer::serializeChar(destination,getType());
    BasicObject::_serialize(destination,this);

}
// }}}

// {{{ deserialize

Nebula* Nebula::deserialize(std::vector<unsigned char>::iterator& it){
    Nebula* ptr=new Nebula();
    BasicObject::_deserialize(it,ptr);
    return ptr;
}


// }}}
