#include "ObjectGraphics.h"

#include "Graphics.h"
#include "BasicObject.h"
#include "Ship.h"
#include "Twirler.h"
#include "Exceptions.h"
#include "BlackHole.h"
#include "Types.h"
#include "Errors.h"
#include "Assert.h"
#include "Nebula.h"
#include "Asteroid.h"
#include "PlasmaBall.h"
#include "CannonBall.h"
#include "Missile.h"

Surface ObjectGraphics::surface;
Metric ObjectGraphics::m;
int ObjectGraphics::show;

void ObjectGraphics::flip(){
    Graphics::flip(surface); 
}

void ObjectGraphics::begin(){
   // Graphics::filledRectangle(surface,NULL,0,0,0,255);
  //  SDL_FillRect(surface.getSurface(),,0);
}

void ObjectGraphics::_drawObject(BasicObject* object, int R,int G,int
        B){
    if (!object->alive) {R=255; G=0; B=0; }
    if (!object->visible) {R/=2; G/=2; B/=2; }

//    fprintf(stderr,"%d\n",m.x(object->position.x));

    try {
    Graphics::line(surface,
            m.x(object->position.x),
            m.y(object->position.y),
            m.x(object->position.x+cos(object->angle)*object->radius),
            m.y(object->position.y+sin(object->angle)*object->radius),
            255*show,255*show,255*show,255);
    } catch (Exception e) {

    }

    try {
    Graphics::circle(surface,m.x(object->position.x),
             m.y(object->position.y),
             abs(m.scaleX(object->radius)+1),
            R*show,G*show,B*show,255);

    } catch (Exception e) {

    }
}

void ObjectGraphics::drawBasicObject(BasicObject* object){
    _drawObject(object,100,100,100);
}

void ObjectGraphics::drawTwirler(Twirler* object){
    _drawObject(object,0,150,0);
}

void ObjectGraphics::drawPlasmaBall(PlasmaBall* object){
    _drawObject(object,0,250,0);
}

void ObjectGraphics::drawCannonBall(CannonBall* object){
    _drawObject(object,150,0,150);
}

void ObjectGraphics::drawMissile(Missile* object){
    _drawObject(object,0,100,250);
}

void ObjectGraphics::drawBlackHole(BlackHole* object){
    _drawObject(object,255,255,255);
}

void ObjectGraphics::drawNebula(Nebula* object){
    _drawObject(object,100,20,70);
}

void ObjectGraphics::drawAsteroid(Asteroid* object){
    _drawObject(object,10,200,170);
}

int RR[]={200,0,0,200,200};
int GG[]={0,200,0,200,0};
int BB[]={0,0,200,0,200};

void ObjectGraphics::drawShip(Ship* ptr){
    if (ptr->isImmutable()) {
        _drawObject(ptr,RR[ptr->player]/3,GG[ptr->player]/3,BB[ptr->player]/3); 
    }   else {
        _drawObject(ptr,RR[ptr->player],GG[ptr->player],BB[ptr->player]);
    }

    return ;

    try {

        Graphics::filledRectangle(surface, 
                m.x(ptr->position.x+10),
                m.y(ptr->position.y+20),
                m.x(ptr->position.x+10+ptr->live/3),
                m.y(ptr->position.y+10),
                255*show,0*show,0*show,255);

        Graphics::rectangle(surface, 
                m.x(ptr->position.x+10),
                m.y(ptr->position.y+20),
                m.x(ptr->position.x+10+100/3),
                m.y(ptr->position.y+10),
                255*show,255*show,0*show,255);
    } catch (Exception e){

    }


}
