#include "Timer.h"
#include <SDL/SDL.h>

double Timer::fpsTime=0.5;

void Timer::start(){
    startTime=SDL_GetTicks()/1000.0;
    lastTime=startTime;
    fpsStartTime=lastTime;
    lastFPS=0;
    ticks=0;
    fpsTicks=0;
}

double Timer::tick(){
    double oldTime=lastTime;
    lastTime=SDL_GetTicks()/1000.0;
    ticks++;
    fpsTicks++;
    if (lastTime-fpsStartTime>fpsTime) {
         lastFPS=fpsTicks/(lastTime-fpsStartTime);
         fpsStartTime=lastTime;
         fpsTicks=0;
    }

    return lastTime-oldTime;
}

double Timer::getTimeFromStart(){
    return lastTime-startTime;
}

double Timer::getFPS(){
    return lastFPS;
}
