#include <iostream>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <errno.h>
#include <cstring>

#include "Proboj.h"
#include "Macro.h"


#include "Errors.h"
#include "Exceptions.h"
#include "Preferences.h"

#include "World.h"
#include <cmath>
#include "Utils.h"
#include "PBE_obj.h"

#define FD 47

#define LOG_FILE "viewer.log"
#define INI_FILE "proboj.ini"
#define PERFORMANCE_LOOPS 500
#define MAX_LOOPS 25000
//#define BENCHMARK


int performanceTimer;
int performanceDelta;
int performanceCounter;
int mouseX;
int mouseY;
int frames=0;

int fd;

World world,tmpWorld;
PlayerResponse playerResponse;
double angle=0;

// {{{ init
int init(){
	cout << "Viewer init" << endl;
	
    playerResponse.fireWeapon=-1;

    Errors::createInstance(LOG_FILE);
    Preferences::createInstance();
    Preferences::_loadFromFile(INI_FILE);

    //Errors::_addError("SDL init done",Errors::NOTICE);

   int width=Preferences::_getInt("/video/resolution/width");
   int height=Preferences::_getInt("/video/resolution/height");
   int bitDepth=Preferences::_getInt("/video/resolution/depth");
    world.initialize("mapa.dat");
    
    Preferences tmp;
    tmp.loadFromFile("viewer.ini");
    int screen=tmp.getInt("/screenNumber");
    PBE_obj::po = new PBE_obj(world.width, world.height, screen);
/*    
    PBE_obj::m.x1=0;
    PBE_obj::m.x2=width;
    PBE_obj::m.y1=height;
    PBE_obj::m.y2=0;
    PBE_obj::m.XSCALE=world.width;
    PBE_obj::m.YSCALE=world.height;
*/
//    tmpWorld.initialize("mapa.dat");

    
    
    Errors::_addError("Video mode OK",Errors::NOTICE);

    /*
    if (TTF_Init() == -1) {
        Errors::_addError("Unable to initialize SDL_ttf",Errors::ERROR);
        return 0;
    }
    Errors::_addError("Font library OK",Errors::NOTICE);
    */


    return 1;

}
// }}}

// {{{ finalize
void finalize(){

    /*
    TTF_Quit();
    Errors::_addError("TTF library closed",Errors::NOTICE);
    */

	delete PBE_obj::po;
}
// }}}


 // {{{ main loop doLoop
int doLoop(){

// ------------------------ SEM NESAHAT ---------------------------------------------
    std::vector<unsigned char> tmp;
    tmp.resize(sizeof(int));
    int ret=::recv(fd,&tmp[0],sizeof(int),MSG_PEEK);
    if(ret==-1) {
		return 0;
    }
    int res=(*(int*)&tmp[0]);
    tmp.resize(res);
    unsigned int data=0;
    while(data<tmp.size()){
        ret=::recv(fd,&tmp[data],res-data,0);
	if(ret==-1) {
		return 0;
	}
	data+=ret;
    }
    //std::cout<<"--------------------Dostal som data velkosti: "<<tmp.size();
    std::vector<unsigned char>::iterator it=tmp.begin()+sizeof(int);
  //  std::cout<<"-----------------------------\n";
  //  for(int i=0;i<tmp.size();i++){
//	std::cout<<(int)tmp[i]<<" ";
 //   }std::cout<<std::endl;
 //   assert(ret==tmp.size(),"SKUSENE RECV");
    assert(tmp[tmp.size()-4]==47&&tmp[tmp.size()-3]==0&&tmp[tmp.size()-2]==0&&tmp[tmp.size()-1]==0,"DOSTAL SOM KREPY PACKET");
    world.deserialize(it);
    //std::cout<<std::endl;
// ------------------------ KONIEC NESAHANIA ----------------------------------------
// ------------------------------ tento kod momentalne vykresluje -------------------------------
    //PBE_obj::show=1;
    PBE_obj::begin();
    world.draw();
    PBE_obj::flip();
// ----------------------------- koniec vykreslovacieho kodu --------------------------------------

    return 1;

}
// }}}

// {{{ main
int main(int argc, char *argv[]){
	cout<<"lol\n";
    std::string type="local";
    std::string host="0.0.0.0";
    int port=0;
    int i=1;
    
    while(i<argc){
	    if(!strcmp(argv[i],"-t")){
		    if(i+1>=argc){
			    std::cerr<<"Bat parameters\n";
			    return 1;
		    }
		    type=std::string(argv[i+1]);
		    i+=2;
	    }else if(!strcmp(argv[i],"-h")){
		    if(i+1>=argc){
			    std::cerr<<"Bat parameters\n";
			    return 1;
		    }
		    host=std::string(argv[i+1]);
		    i+=2;
	    }else if(!strcmp(argv[i],"-p")){
		    if(i+1>=argc){
			    std::cerr<<"Bat parameters\n";
			    return 1;
		    }
		    port=atoi(argv[i+1]);
		    i+=2;

	    }else {
		    std::cerr<<"Bat parameters\n";
		    return 1;
	    }
    }
	cout<<"lol2\n";
    if(type=="local"){
	    fd=FD;
    }else if(type=="remote"){
    	cout<<"lol3\n";
	    struct sockaddr_in addr;
	    if (inet_pton(AF_INET, host.c_str(), &addr.sin_addr.s_addr) == -1) {
		    std::cerr<<"inet_pton error: "<<strerror(errno)<<std::endl;
		    return 1;
	    }
	    addr.sin_port = htons(port);
	    addr.sin_family = AF_INET;
	    fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	    if (fd == -1) {
		    std::cerr<<"Nepodarilo sa otvorit socket "<<strerror(errno)<<std::endl;
		    return 1;
	    }
    	cout<<"lol3.5\n";

	    if (::connect(fd, (struct sockaddr*)&addr, sizeof(addr))) {
		    std::cerr<<"Nepodaril sa connect "<<strerror(errno)<<std::endl;
		    return 1;
	    }
    	cout<<"lol4\n";
    }else {
	    std::cerr<<"Bat type\n";
	    return 0;
    }
    std::cout<<"Hrac nastartoval\n";
    try {
        if (init()) {
            while (doLoop());
        }

        finalize();
    } catch (Exception &e){
	shutdown(fd,SHUT_RDWR);
	close(fd);
        printf("There was an exception %s %s\n",
                e.what(),e.getStringStack().c_str());
    } catch (std::exception &e){
	shutdown(fd,SHUT_RDWR);
	close(fd);
        printf("There was an exception %s\n",e.what());
    }
shutdown(fd,SHUT_RDWR);
close(fd);


}

// }}}
