#include <iostream>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <fcntl.h>
#include <sstream>

#include "events.h"
#include "World.h"
#include "Communication.h"
#include "PlayerResponse.h"

#define DEAD_NO_PACKET 0
#define DEAD_HAVE_PACKET 1
#define ALIVE_NO_PACKET 2
#define ALIVE_WAIT_FOR_PACKET 3
#define ALIVE_HAVE_PACKET 4

#define WAITING_FOR_DATA 1
#define SENDING 2
#define RECEIVING 4
#define DEAD 0

#define RES_DEAD 1
#define RES_COMPLETE 2
#define RES_PENDING 4

#define FD 47

std::string getPl(int i){
    char s[100];
    sprintf(s,"player%d",i);
    return std::string(s);
}

std::string getSh(int i){
    char s[100];
    sprintf(s,"ship%d",i);
    return std::string(s);
}



CommunicationShip::CommunicationShip(int player,int ships,Config *config){
	this->player=player;
	this->ships=ships;
	this->state=DEAD;
//	this->world=NULL;
	this->config=config;
	this->sfd=-1;
	this->pid=-1;
	this->response.resize(ships);
	std::string pl=getPl(this->player);
	if(ships==0){
	    this->active=false;
	    return;
	}else this->active=true;
//	std::string sh=pl+"."+getSh(this->ship);//TODO Config
	std::string tp=this->config->getString(pl+".type");
	int port=this->config->getInt(pl+".port");
//	std::cout<<port<<" "<<player<<" "<<ship<<std::endl;
	if(tp=="remote"){
		struct sockaddr_in addr;

		this->sfd=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
		if(this->sfd==-1){
			std::cerr<<"Error, nepodarilo sa vytvorit socket: "<<strerror(errno)<<std::endl;
			this->sfd=-1;
		}

		inet_pton(AF_INET, "0.0.0.0", &addr.sin_addr.s_addr);

		addr.sin_port = htons(port);
		addr.sin_family = AF_INET;

		if (bind(this->sfd, (struct sockaddr *) &addr, sizeof(addr))==-1){
			std::cerr<<"Error, nepodarilo sa bindnut socket: "<<strerror(errno)<<std::endl;
			this->sfd=-1;
		}
		listen(this->sfd,10);
	}
}

CommunicationShip::~CommunicationShip(){
	std::cout<<"Zabijam proces: "<<this->pid<<std::endl;
	if(this->pid!=-1)kill(this->pid,9);
	shutdown(this->sfd,SHUT_RDWR);
	close(this->sfd);
	if(this->sfd!=-1)close(this->sfd);
}


int runPlayer(const char *exename, int &pid){
//  std::cout<<exename<<std::endl;
    int sv[2];
  int res;
    int fd; 
  res = socketpair(PF_UNIX , SOCK_DGRAM,0,sv);
  if (res) {
    printf(" sockets sucks\n");
    return -1 ;
  }
  fcntl(sv[0],F_SETFD,FD_CLOEXEC);
  fd=sv[0];
  
  //start new process;
  if ((pid=fork())==0) {
    //child branch
    //close(0);
    //close(1);
    //close(2);
    dup2(sv[1],FD);
    std::stringstream ss(exename);
    std::vector<std::string> param;
    std::string aaaa;
    while(ss>>aaaa){
	param.push_back(aaaa);
    }
    char **a=new char*[param.size()+1];
    for(unsigned int i=0;i<param.size();i++)a[i]=(char*)param[i].c_str();
    a[param.size()]=NULL;
    res = execvp(a[0],a);
    if (res == -1 ){
      printf("execlp errror  \n");

    }
    exit(0);
  } else {
    if(pid==-1){
	std::cout<<"Nepodarilo sa forknut: "<<strerror(errno)<<std::endl;
	return -1;
    }
    //parent
    close(sv[1]);
    return fd;
  }
  return -1;
}

int CommunicationShip::connectWithPlayer(){//Netreba menit
	std::string pl=getPl(this->player);
//	std::string sh=pl+"."+getSh(this->ships);
	std::string tp=this->config->getString(pl+".type");
	std::string execname=this->config->getString(pl+".execname");
	if(tp=="local"){
		this->fd=runPlayer(execname.c_str(),this->pid);
		if(this->fd==-1)return RES_DEAD;
//		std::cout<<"File descriptor is: "<<this->fd<<std::endl;
		return 0;
	}else if(tp=="remote"){
		if(this->sfd==-1){
			std::cerr<<"Nemozem spustit hraca, nie je vytvoreny socket\n";
			return RES_DEAD;
		}
		struct pollfd p;
		p.fd = this->sfd;
		p.events = POLLIN | POLLPRI;
		p.revents = 0;
	    	poll(&p, 1, 0);
		if (p.revents > 0){
			int conn = accept(this->sfd, NULL, NULL);
			if (conn == -1) {
				std::cerr<<"Nepodarilo sa akceptovat spojenie: "<<strerror(errno)<<std::endl;;
				return RES_DEAD;
			};
			this->fd=conn;
			return 0;
		}else return RES_DEAD;

	}else{
		std::cerr<<"Error: "<<getPl(this->player)<<".type: "<<this->config->getString(getPl(this->player))<<std::endl;
		return RES_DEAD;
	}
}


int CommunicationShip::trySend(){//netreba menit
//	std::cout<<"Server skusa poslat: "<<this->data_v.size()<<std::endl;
        int sndlen=this->data_v.size()-this->data_send_len;
        int ret=::send(this->fd,&this->data_v[0]+this->data_send_len,sndlen,MSG_NOSIGNAL);
//	std::cout<<"Server poslal: "<<ret<<" bajtof\n";
	if(ret>=sndlen){
	       this->data_v.resize(sizeof(int));
	       this->data_receive_len=0;
	       if(ret>sndlen) std::cerr<<"Send poslal viac, ako mal. Nech sa mu to vrati na detoch\n";
	       return RES_COMPLETE;
	}
	if(ret==-1){
		if(errno==EPIPE||errno==ECONNRESET||errno==ENOTCONN||errno==ECONNREFUSED){
			std::cerr<<"Hrac umrel. Nech sa mu to vrati na detoch.\n";
			//umrel
			shutdown(this->fd,SHUT_RDWR);
			close(this->fd);
			this->data_send_len=0;
			this->fd=-1;

			return RES_DEAD;
		}
		std::cerr<<"Nastala chyba, ktoru mic neosetruje. Nech sa mu to vrati na detoch: "<<errno<<" "<<strerror(errno)<<std::endl;
		return RES_PENDING;//WTF??? nemalo by nastat
	}
        //poslal nejake data
	this->data_send_len+=ret;
	return RES_PENDING;
}

int CommunicationShip::tryReceive(){
	//int ret=::recv(this->fd,&this->data_v[0]+this->data_receive_len,this->data_v.size()-this->data_receive_len,MSG_DONTWAIT);
	int ret=::recv(this->fd,&this->data_v[0],this->data_v.size(),MSG_DONTWAIT|MSG_PEEK);
	if(ret==-1){
		if(errno==EPIPE||errno==ECONNRESET){
			shutdown(this->fd,SHUT_RDWR);
			close(this->fd);
			this->data_send_len=0;
			this->fd=-1;
			return RES_DEAD;
		}
		if(errno==EAGAIN)return RES_PENDING;
;		std::cerr<<"Receivujem a dostal som divnu chybu."<<strerror(errno)<<"\n";
		return RES_PENDING;//WTF??? nemalo by nastat
	}
	if(ret==(int)this->data_v.size()&&this->data_v.size()==sizeof(int)){
		this->data_v.resize(*((int*)&this->data_v[0]));
		this->data_receive_len=ret;
//		std::cout<<"Sever dostal data, idem receivovat: "<<this->data_v.size()<<" bajtof\n";
		//int ret=::recv(this->fd,&this->data_v[0]+this->data_receive_len,this->data_v.size()-this->data_receive_len,MSG_DONTWAIT);
		int ret=::recv(this->fd,&this->data_v[0],this->data_v.size(),MSG_DONTWAIT|MSG_PEEK);
//		std::cout<<"Server dostak nejake data: "<<ret<<" bajtof\n";
		if(ret==-1){
			if(errno==EPIPE||errno==ECONNRESET||errno==ENOTCONN||errno==ECONNREFUSED){
				this->data_send_len=0;
				shutdown(this->fd,SHUT_RDWR);
				close(this->fd);
				this->fd=-1;
				return RES_DEAD;
			}
			if(errno==EAGAIN)return RES_PENDING;
			std::cerr<<"Receivujem a dostal som divnu chybu."<<strerror(errno)<<"\n";
			return RES_PENDING;
		}
		//this->data_receive_len+=ret;
		this->data_receive_len=ret;
	}
	if(this->data_receive_len==(int)this->data_v.size()){
		unsigned int dt=0;
		while(dt<data_v.size()){
			int ret=::recv(this->fd,&this->data_v[dt],this->data_v.size()-dt,0);
			dt+=ret;
			if(ret==-1){
				if(errno==EPIPE||errno==ECONNRESET||errno==ENOTCONN||errno==ECONNREFUSED){
	    				this->data_send_len=0;
					shutdown(this->fd,SHUT_RDWR);
					close(this->fd);
					this->fd=-1;
					return RES_DEAD;
				}
				if(errno==EAGAIN)return RES_PENDING;
				std::cerr<<"Receivujem a dostal som divnu chybu."<<strerror(errno)<<"\n";
				return RES_PENDING;

			}
		}
		//response=new PlayerResponse;
		for(unsigned int i=0;i<response.size();i++)
			if(response[i]!=NULL)
				delete response[i];
		std::vector<unsigned char>::iterator it=this->data_v.begin()+sizeof(int);
		for(unsigned int  i=0;i<this->response.size();i++){
			response[i]=new PlayerResponse;
//		    std::cout<<"R";
//			for(std::vector<unsigned char>::iterator ii=it;ii!=this->data_v.end();ii++)std::cout<<" "<<(int)*ii;std::cout<<std::endl;
			*response[i]=response[i]->deserialize(it);
		//	std::cout<<i<<" response "<<response[i]->fireWeapon<<std::endl;
		}
//		(*response)=response->deserialize(it);
		this->data_v.resize(0);
		return RES_COMPLETE;
	}
	return RES_PENDING;
}

int CommunicationShip::send(std::vector<unsigned char> &data){//snad netreba menit
	if(!active)return 0;
        if(this->state==DEAD){
		this->state=WAITING_FOR_DATA;
		int res=this->connectWithPlayer();
		if(res==RES_DEAD)this->state=DEAD;
	}
	if(this->state==DEAD)return 0;
	if(this->state==WAITING_FOR_DATA){
		this->data_v.resize(data.size()+4);
		std::copy(data.begin(),data.end(),this->data_v.begin()+4);
		*(int*)&this->data_v[0]=(int)this->data_v.size();
		this->data_send_len=0;
		this->state=SENDING;
	}
	if(this->state==SENDING){
		int res=this->trySend();
		if(res==RES_DEAD)this->state=DEAD;
		if(res==RES_COMPLETE){
			this->state=RECEIVING;
//		        std::cout<<"Server sended\n";
		}
	}
	return 0;
}

PlayerResponse* CommunicationShip::receive(int ship){
	if(!active)return NULL;
//	PlayerResponse *response=NULL;
	if(this->state==DEAD)return new PlayerResponse;
	if(this->state==SENDING){
		int res=this->trySend();
		if(res==RES_DEAD)this->state=DEAD;
		if(res==RES_COMPLETE)this->state=RECEIVING;
	}
	if(this->state==RECEIVING){
		int res=this->tryReceive();
		if(res==RES_DEAD)this->state=DEAD;
		if(res==RES_COMPLETE){
			this->state=WAITING_FOR_DATA;
//			std::cout<<"Server received\n";
			PlayerResponse *s=response[ship];
			response[ship]=NULL;
			return s;
		}
	}
	if(this->state==WAITING_FOR_DATA){
		PlayerResponse *s=response[ship];
		response[ship]=NULL;
		return s;

	}
	return NULL;
}

int CommunicationShip::connected(){
	if(!active) return 0;
	if(this->state==DEAD){
		this->state=WAITING_FOR_DATA;
		int res=this->connectWithPlayer();
		if(res==RES_DEAD)this->state=DEAD;
	}
	if(this->state==DEAD)return 0;else return this->ships;
}

#define VIEWER_OK 0
#define VIEWER_DEAD 1

CommunicationViewer::CommunicationViewer(int fd){
	this->fd=fd;
	this->sending=false;
	this->pid=-1;
}

CommunicationViewer::CommunicationViewer(int fd,int pid){
	this->fd=fd;
	this->sending=false;
	this->pid=pid;
}

CommunicationViewer::~CommunicationViewer(){
	if(this->pid!=-1)kill(this->pid,9);
	shutdown(this->fd,SHUT_RDWR);
	close(this->fd);
}

int CommunicationViewer::SendData(std::vector<unsigned char>&data){
	if(!this->sending){
	    this->data_v.resize(data.size()+sizeof(int));
	    copy(data.begin(),data.end(),this->data_v.begin()+4);
	    *(unsigned int*)(&this->data_v[0])=this->data_v.size();
	    this->data_send_len=0;
	    this->sending=true;
	}
	int sndlen=this->data_v.size()-this->data_send_len;
//	std::cout<<"Posielam data velkosti "<<this->data_v.size()<<std::endl;
        int ret=::send(this->fd,&this->data_v[0]+this->data_send_len,sndlen,MSG_NOSIGNAL);
//	for(unsigned int i=0;i<this->data_v.size();i++)std::cout<<(int)this->data_v[i]<<" ";std::cout<<std::endl;
	if(ret>=sndlen){
	       if(ret>sndlen) std::cerr<<"Send poslal viac, ako mal. Nech sa mu to vrati na detoch\n";
	       this->sending=false;
	       return VIEWER_OK;
	}
	if(ret==-1){
		if(errno==EPIPE||errno==ECONNRESET||errno==ENOTCONN||errno==ECONNREFUSED){
			std::cerr<<"Viewer umrel. Nech sa mu to vrati na detoch.\n";
			//umrel
			shutdown(this->fd,SHUT_RDWR);
			close(this->fd);
			return VIEWER_DEAD;
		}
		std::cerr<<"Nastala chyba, viewer, ktoru mic neosetruje. Nech sa mu to vrati na detoch: "<<errno<<" "<<strerror(errno)<<std::endl;
		return VIEWER_OK;//WTF??? nemalo by nastat
	}
        //poslal nejake data
//	std::cout<<"Neposlal som to cele\n";
	this->data_send_len+=ret;//TODO oprav ide tu BOL BUG
	return VIEWER_OK;

    
}

Communication::Communication (){
	this->config=new Config("communication.ini");
	this->ships.resize(0);
	this->localView.resize(this->config->getInt("viewer.local"));
	for(unsigned int i=0;i<localView.size();i++){
		this->localView[i]=NULL; 
	}
	this->remoteView.resize(0);
	this->data_stat.resize(0);
	this->remoteStats.resize(0);
	this->localStats.resize(this->config->getInt("stats.local"));
	for(unsigned int i=0;i<localStats.size();i++)
	    this->localStats[i]=NULL;
	this->event.resize(0);
	this->kill.resize(0);
}

Communication::~Communication (){
	delete this->config;
	std::cout<<"Idem spachat genocidu na hracoch\n";
	for(unsigned int i=0;i<this->ships.size();i++)
	    delete this->ships[i];
	for(unsigned int i=0;i<this->remoteView.size();i++)
	    delete this->remoteView[i];
	for(unsigned int i=0;i<this->localView.size();i++)
	    if(this->localView[i]!=NULL)delete this->localView[i];
	for(unsigned int i=0;i<this->remoteStats.size();i++)
	    delete this->remoteStats[i];
	for(unsigned int i=0;i<this->localStats.size();i++)
	    delete this->localStats[i];
	std::cout<<"zatvaram sockety\n";
	shutdown(this->remotefd,SHUT_RDWR);
	shutdown(this->remotefdstat,SHUT_RDWR);
	close(this->remotefd);
	close(this->remotefdstat);


}

void Communication::initializeServer(){
	signal(SIGCLD, SIG_IGN);//TODO -- ak umre deco, tak v pazi je to

	struct sockaddr_in addr;
	int port=this->config->getInt("viewer.port");

	this->remotefd=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	
	if(this->remotefd==-1){
		std::cerr<<"Error, nepodarilo sa vytvorit socket: "<<strerror(errno)<<std::endl;
		this->remotefd=-1;
	}

	inet_pton(AF_INET, "0.0.0.0", &addr.sin_addr.s_addr);

	addr.sin_port = htons(port);
	addr.sin_family = AF_INET;

	if (bind(this->remotefd ,(struct sockaddr *) &addr, sizeof(addr))==-1){
		std::cerr<<"Error, nepodarilo sa bindnut socket: "<<strerror(errno)<<std::endl;
		this->remotefd=-1;
	}
	listen(this->remotefd,10);

	port=this->config->getInt("stats.port");

	this->remotefdstat=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	
	if(this->remotefdstat==-1){
		std::cerr<<"Error, nepodarilo sa vytvorit socket: "<<strerror(errno)<<std::endl;
		this->remotefdstat=-1;
	}

	inet_pton(AF_INET, "0.0.0.0", &addr.sin_addr.s_addr);

	addr.sin_port = htons(port);
	addr.sin_family = AF_INET;

	if (bind(this->remotefdstat ,(struct sockaddr *) &addr, sizeof(addr))==-1){
		std::cerr<<"Error, nepodarilo sa bindnut socket: "<<strerror(errno)<<std::endl;
		this->remotefdstat=-1;
	}
	listen(this->remotefdstat,10);

}

void Communication::initializeClient(){
}

int Communication::playersConnected(){
	int count=0;
	for(unsigned int i=0;i<this->ships.size();i++)
		count+=this->ships[i]->connected();
	return count;
}

int Communication::sendNewGame (CommunicationGraph* comm,
	                 std::vector<int> ships){
	for(unsigned int i=0;i<this->ships.size();i++)
		delete this->ships[i];
	this->ships.resize(0);
	std::cout<<"NewGame\n";
	for(unsigned int i=0;i<ships.size();i++){
//		std::cout<<i<<" "<<j<<std::endl;
		this->ships.push_back(new CommunicationShip(i,ships[i],this->config));	
	}
	return 0;
}

int Communication::sendPlayerData(World *world){
	this->world=world;
	this->data.resize(0);
	world->serialize(this->data);
	for(unsigned int i=0;i<this->ships.size();i++){
		this->ships[i]->send(data);
	}
	return 0;
}


PlayerResponse* Communication::receivePlayerResponse (int player,int ship){
	return this->ships[player]->receive(ship);
}

int Communication::sendDataToViewer(World* world){
	this->data.resize(0);
	world->serialize(this->data);
	//checni nove pripojenia
	if(this->remotefd==-1){
	}else{
		bool gogo=true;
		while(gogo){
			struct pollfd p;
			p.fd = this->remotefd;
			p.events = POLLIN | POLLPRI;
			p.revents = 0;
		    	poll(&p, 1, 0);
			gogo=false;
			if (p.revents > 0){
				int conn = accept(this->remotefd, NULL, NULL);
				gogo=true;
				if (conn == -1) {
					std::cerr<<"Nepodarilo sa akceptovat spojenie: "<<strerror(errno)<<std::endl;;
				};
				this->remoteView.push_back(new CommunicationViewer(conn));
			}
		}
	}

	for(unsigned int i=0;i<this->remoteView.size();i++){
		if(this->remoteView[i]->SendData(this->data)==VIEWER_DEAD){
			delete this->remoteView[i];
			this->remoteView[i]=this->remoteView[this->remoteView.size()-1];
			this->remoteView.resize(this->remoteView.size()-1);
		}
	}
	for(unsigned int i=0;i<this->localView.size();i++){
		if(this->localView[i]==NULL){
		    int sv[2];
		    int res;
		    int fd; 
		    int pid;//TODO kill pid
		    std::string exename=this->config->getString("viewer.execname");
		    res = socketpair(PF_UNIX , SOCK_DGRAM,0,sv);
		    if (res) {
		        printf(" sockets sucks\n");
		        return -1 ;
		    }
		    fcntl(sv[0],F_SETFD,FD_CLOEXEC);
		    fd=sv[0];
  
		    //start new process;
		    if ((pid=fork())==0) {
			//child branch
			//close(0);
			//close(1);
			//close(2);
			dup2(sv[1],FD);
			res = execlp(exename.c_str(),"noparam",NULL);
			if (res == -1 ){
			    printf("execlp errror  \n");
			}
			exit(0);
		    } else {
			if(pid==-1){
			    std::cout<<"Nepodarilo sa forknut: "<<strerror(errno)<<std::endl;
			    return 0;
			}
			//parent
			close(sv[1]);
			localView[i]=new CommunicationViewer(fd,pid);
		    }
		    }else{
			if(this->localView[i]->SendData(this->data)==VIEWER_DEAD){
			    delete this->localView[i];
			    this->localView[i]=NULL;
		    }
		}
	}
        return 0;
}

int Communication::sendStatisticsData (PlayerStatistics *stats){
    {
	//serializacia
	this->data_stat.resize(0);
	stats->serialize(this->data_stat);//Mohlo by fungovat
	int sz=this->data_stat.size();
	this->data_stat.resize(this->data_stat.size()+4);
	*(unsigned int*)(&this->data_stat[sz])=this->event.size();
	for(unsigned int i=0;i<this->event.size();i++)this->data_stat.push_back(event[i]);
	sz=this->data_stat.size();
	this->data_stat.resize(this->data_stat.size()+4);
	*(unsigned int*)(&this->data_stat[sz])=this->kill.size();
	for(unsigned int i=0;i<this->kill.size();i++){
	    this->data_stat.push_back(kill[i].first);
	    this->data_stat.push_back(kill[i].second);
	}
	kill.resize(0);
	event.resize(0);

    }	
	//koniec serializacie
	//checni nove pripojenia
	if(this->remotefdstat==-1){
	}else{
		bool gogo=true;
		while(gogo){
			struct pollfd p;
			p.fd = this->remotefdstat;
			p.events = POLLIN | POLLPRI;
			p.revents = 0;
		    	poll(&p, 1, 0);
			gogo=false;
			if (p.revents > 0){
				int conn = accept(this->remotefdstat, NULL, NULL);
				gogo=true;
				if (conn == -1) {
					std::cerr<<"Nepodarilo sa akceptovat spojenie: "<<strerror(errno)<<std::endl;;
				};
				this->remoteStats.push_back(new CommunicationViewer(conn));
			}
		}
	}

	for(unsigned int i=0;i<this->remoteStats.size();i++){
		if(this->remoteStats[i]->SendData(this->data_stat)==VIEWER_DEAD){
			delete this->remoteStats[i];
			this->remoteStats[i]=this->remoteStats[this->remoteStats.size()-1];
			this->remoteStats.resize(this->remoteStats.size()-1);
		}
	}
	for(unsigned int i=0;i<this->localStats.size();i++){
		if(this->localStats[i]==NULL){
		    int sv[2];
		    int res;
		    int fd; 
		    int pid;//TODO kill pid
		    std::string exename=this->config->getString("stats.execname");
		    res = socketpair(PF_UNIX , SOCK_DGRAM,0,sv);
		    if (res) {
		        printf(" sockets sucks\n");
		        return -1 ;
		    }
		    fcntl(sv[0],F_SETFD,FD_CLOEXEC);
		    fd=sv[0];
  
		    //start new process;
		    if ((pid=fork())==0) {
			//child branch
			//close(0);
			//close(1);
			//close(2);
			dup2(sv[1],FD);
			res = execlp(exename.c_str(),"noparam",NULL);
			if (res == -1 ){
			    printf("execlp errror  \n");
			}
			exit(0);
		    } else {
			if(pid==-1){
			    std::cout<<"Nepodarilo sa forknut: "<<strerror(errno)<<std::endl;
			    return 0;
			}
			//parent
			close(sv[1]);
			localStats[i]=new CommunicationViewer(fd,pid);
		    }
		    }else{
			if(this->localStats[i]->SendData(this->data_stat)==VIEWER_DEAD){
			    delete this->localStats[i];
			    this->localStats[i]=NULL;
		    }
		}
	}
        return 0;

}

void Communication::shipKilledShip(int killer, int victim){
    kill.push_back(std::make_pair(killer,victim));
}
 
void Communication::blackHoleKilledShip(int victim){
    kill.push_back(std::make_pair(BLACKHOLE_KILLER,victim));
}
 
void Communication::impactKilledShip(int victim){
    kill.push_back(std::make_pair(IMPACT_KILLER,victim));
}
 
void Communication::explosionKilledShip(int victim){
    kill.push_back(std::make_pair(EXPLOSION_KILLER,victim));
}
 
void Communication::shootPlasma(){
    event.push_back(EVENT_SHOOT_PLASMA);
}

void Communication::shootMissile(){
    event.push_back(EVENT_SHOOT_MISSILE);
}

void Communication::shootCannon(){
    event.push_back(EVENT_SHOOT_CANNON);
}

void Communication::explode(){
    event.push_back(EVENT_EXPLODE);
}
 
void Communication::plasmaToPlasmaExplode(){
    event.push_back(EVENT_PLASMA_TO_PLASMA);
}
 



/*
PlayerResponse* CommunicationShip::communicationFoo(World *world){
	//TODO: pridat MSG_DONTWAIT a moznost poslat menej dat, nez mu poslem:-) done?
        switch(this->state){
		case ALIVE_NO_PACKET://done?
		{
			if(world!=NULL){
				std::cerr<<"Mam receovovat, ale chces po mme, aby som sendoval. Nech sa ti to vrati na detoch,\nPokracujem v receivovani.\n";
			}
			int ret=::recv(this->fd,&this->data_v[0]+this->data_receive_len,this->data_v.size()-this->data_receive_len,MSG_DONTWAIT);
			if(ret==-1){
				if(errno==EPIPE||errno==ECONNRESET){
					this->data_send_len=0;
					this->state=DEAD_NO_PACKET;
					this->fd=-1;
					shutdown(this->fd,SHUT_RDWR);
					close(this->fd);
					break;
				}
				if(errno==EAGAIN)break;
				std::cerr<<"Receivujem a dostal som divnu chybu.\n";
				break;
			}
			if(ret==(int)this->data_v.size()&&this->data_v.size()==sizeof(int)){
				this->data_v.resize(*((int*)this->data_v[0]));
				this->data_receive_len=ret;
				int ret=::recv(this->fd,&this->data_v[0]+this->data_receive_len,this->data_v.size()-this->data_receive_len,MSG_DONTWAIT);
				if(ret==-1){
					if(errno==EPIPE||errno==ECONNRESET){
						this->data_send_len=0;
						this->state=DEAD_NO_PACKET;
						this->fd=-1;
						shutdown(this->fd,SHUT_RDWR);
						close(this->fd);
						break;
					}
					if(errno==EAGAIN)break;
					std::cerr<<"Receivujem a dostal som divnu chybu.\n";
					break;
				}
				this->data_receive_len+=ret;
			}
			if(this->data_receive_len==(int)this->data_v.size()){
				this->state=ALIVE_WAIT_FOR_PACKET;
				PlayerResponse *resp=new PlayerResponse;
				std::vector<unsigned char>::iterator it=this->data_v.begin()+sizeof(int);
				(*resp)=resp->deserialize(it);
				this->data_v.resize(0);
				return resp;
			}

		}break;
		case DEAD_NO_PACKET:
		{
		    //TODO nastartovat hraca. poslat ze nic nespravil, nastavit sa na cakanie done?
			if(this->config->getString(getPl(this->player)+".type")=="local"){
	 			this->fd=runPlayer(this->config->getString(getPl(this->player)+".execname").c_str(),this->pid);
				if(world==NULL){
					this->state=ALIVE_WAIT_FOR_PACKET;//BUG;
					return new PlayerResponse;
				}else{
					this->world=world;
					this->data_v.resize(sizeof(int));
					this->world->serialize(this->data_v);
					*((int*)&(this->data_v[0]))=this->data_v.size();
					this->data_send_len=0;
					this->state=ALIVE_HAVE_PACKET;
				}
			}else{
				std::cerr<<"Error: "<<getPl(this->player)<<".type: "<<this->config->getString(getPl(this->player))<<std::endl;
				return NULL;
			}
							
	        }break;
		case DEAD_HAVE_PACKET:
			//TODO: spustit hraca, poslat packet done?
			if(this->config->getString(getPl(this->player)+".type")=="local"){
	 			this->fd=runPlayer(this->config->getString(getPl(this->player)+".execname").c_str(),this->pid);
	    			this->data_send_len=0;
		    		this->state=ALIVE_HAVE_PACKET;
			}else{
				std::cerr<<"Error: "<<getPl(this->player)<<".type: "<<this->config->getString(getPl(this->player))<<std::endl;
				return NULL;

			}
		{
		}break;
		case ALIVE_WAIT_FOR_PACKET://done?
		{
			if(world==NULL)break;
			if(this->world!=NULL){
			    std::cerr<<"Nemam world, ale mam world. Nech sa mu to vrati na detoch\n";
			    break;
			}
			this->world=world;
			this->data_v.resize(sizeof(int));
			this->world->serialize(this->data_v);
			*((int*)&(this->data_v[0]))=this->data_v.size();
			this->data_send_len=0;
			this->state=ALIVE_HAVE_PACKET;
		}
		case ALIVE_HAVE_PACKET://done?
		{
		    //TODO: skusit poslat packet
		    int sndlen=this->data_v.size()-this->data_send_len;
		    int ret=::send(this->fd,&this->data_v[0]+this->data_send_len,sndlen,MSG_NOSIGNAL);
		    if(ret>=sndlen){
			   this->state=ALIVE_NO_PACKET; 
			   delete this->world;
			   this->world=NULL;
			   //delete this->data;
			   this->data_v.resize(sizeof(int));
			   this->data_receive_len=0;
//;			   this->data=&this->data_v[0];
			    if(ret>sndlen) std::cerr<<"Send poslal viac, ako mal. Nech sa mu to vrati na detoch\n";
			   break;
		    }
		    if(ret==-1){
			    if(errno==EPIPE||errno==ECONNRESET){
				    std::cerr<<"Hrac umrel. Nech sa mu to vrati na detoch.\n";
				    //umrel
				    this->data_send_len=0;
				    this->state=DEAD_HAVE_PACKET;
				    this->fd=-1;
				    shutdown(this->fd,SHUT_RDWR);
				    close(this->fd);
				    break;
			    }
			    std::cerr<<"Nastala chyba, ktoru mic neosetruje. Nech sa mu to vrati na detoch: "<<errno<<std::endl;
			    break;
		    }
		    //poslal nejake data
		    this->data_send_len-=ret;
		}break;
		default:
		{
			std::cerr<<"Communication ship je v divnom stave. Nech sa mu to vrati na detoch\n";
		}
	}
	return NULL;
}

int Communication::sendPlayerData (int player,
	                        int ship,
	                        World* world){
        if(this->ships[player][ship]->communicationFoo(world)!=NULL){
		std::cerr<<"Hrac ("<<player<<","<<ship<<") mal posielat, ale receivoval. Nech sa mu to vrati na detoch!!!\n"; 
	}
	return 0;
	
}


*/

